#ifndef EFL_GENERATED_EVAS_RECTANGLE_HH
#define EFL_GENERATED_EVAS_RECTANGLE_HH

extern "C"
{
#include <Efl.h>
}
#include <Eo.hh>

#include <eo_cxx_interop.hh>

extern "C"
{
#include "evas_rectangle.eo.h"
}

#include "evas_object.eo.hh"

namespace evas {

struct rectangle;

}

namespace eo_cxx {

namespace evas {

struct rectangle
{

   static Eo_Class const* _eo_class()
   {
      return(EVAS_RECTANGLE_CLASS);
   }

   operator ::evas::rectangle() const;
   operator ::evas::rectangle&();
   operator ::evas::rectangle const&() const;

   template <typename D>
   struct address_of
   {
      operator ::evas::rectangle*() const { return static_cast<::evas::rectangle*>(static_cast<D const*>(this)->p); }
      operator ::evas::rectangle const*() const { return static_cast<::evas::rectangle const*>(static_cast<D const*>(this)->p); }
   };

   template <typename D>
   struct address_const_of
   {
      operator ::evas::rectangle const*() const { return static_cast<::evas::rectangle const*>(static_cast<D const*>(this)->p); }
   };

private:
   Eo* _concrete_eo_ptr() const
   {
      return static_cast<::efl::eo::concrete const*>(static_cast<void const*>(this))->_eo_ptr();
   }

};

}

}

namespace evas {

struct rectangle
      : ::efl::eo::concrete
      , ::eo_cxx::eo::base
      , ::eo_cxx::evas::common_interface
      , ::eo_cxx::evas::object
{
   rectangle(::efl::eo::parent_type _p = (::efl::eo::parent = nullptr))
      : rectangle(_ctors_call(_p))
   {}

   /// @brief Eo Constructor.
   ///
   /// Constructs the object from an Eo* pointer stealing its ownership.
   ///
   /// @param eo The Eo object pointer.
   ///
   explicit rectangle(Eo* eo)
      : ::efl::eo::concrete(eo)
   {}

   /// @brief nullptr_t Constructor.
   ///
   /// Constructs an empty (null) object.
   ///
   explicit rectangle(std::nullptr_t)
      : ::efl::eo::concrete(nullptr)
   {}

   /// @brief Copy Constructor.
   ///
   rectangle(rectangle const& other)
      : rectangle(eo_ref(other._eo_ptr()))
   {}

   ~rectangle() {}


   static Eo_Class const* _eo_class()
   {
      return(EVAS_RECTANGLE_CLASS);
   }

   struct address_of
      : ::eo_cxx::evas::rectangle::address_of<address_of>
      , ::eo_cxx::eo::base::address_of<address_of>
      , ::eo_cxx::evas::common_interface::address_of<address_of>
      , ::eo_cxx::evas::object::address_of<address_of>
      , ::efl::eo::detail::concrete_address_of
   {
      explicit address_of(::evas::rectangle* p)
         : ::efl::eo::detail::concrete_address_of(p)
      {}
   };
   address_of operator&() { return address_of(this); }

   struct address_const_of
      : ::eo_cxx::evas::rectangle::address_const_of<address_const_of>
      , ::eo_cxx::eo::base::address_const_of<address_const_of>
      , ::eo_cxx::evas::common_interface::address_const_of<address_const_of>
      , ::eo_cxx::evas::object::address_const_of<address_const_of>
      , ::efl::eo::detail::concrete_address_const_of
   {
      explicit address_const_of(::evas::rectangle const* p)
         : ::efl::eo::detail::concrete_address_const_of(p)
      {}
   };
   address_const_of operator&() const { return address_const_of(this); }

private:
   static Eo* _ctors_call(::efl::eo::parent_type _p)
   {
      Eo* _ret_eo = eo_add_ref(EVAS_RECTANGLE_CLASS, _p._eo_raw, );

      return _ret_eo;
   }

      Eo* _concrete_eo_ptr() const { return _eo_ptr(); }
};

static_assert(sizeof(::evas::rectangle) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<::evas::rectangle>::value, "");

}

inline ::eo_cxx::evas::rectangle::operator ::evas::rectangle() const
{
   return *static_cast<::evas::rectangle const*>(static_cast<void const*>(this));
}

inline ::eo_cxx::evas::rectangle::operator ::evas::rectangle&()
{
   return *static_cast<::evas::rectangle*>(static_cast<void*>(this));
}

inline ::eo_cxx::evas::rectangle::operator ::evas::rectangle const&() const
{
   return *static_cast<::evas::rectangle const*>(static_cast<void const*>(this));
}

namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::evas::rectangle >
{
   template <typename T>
   struct type
         : virtual operations< ::evas::object >::template type<T>
   {
   };
};


template<>
struct operation_description_class_size< ::evas::rectangle >
{
   static const int value = 0 + operation_description_class_size<::evas::object >::value;
};

template <typename T>
int initialize_operation_description(::efl::eo::detail::tag<::evas::rectangle>
                                 , Eo_Op_Description* ops)
{
   (void)ops;
   initialize_operation_description<T>(::efl::eo::detail::tag<::evas::object>(), &ops[0]);
   return 0;
}
inline void
call_constructor(::efl::eo::detail::tag< ::evas::rectangle >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               ::efl::eo::detail::args_class<::evas::rectangle, ::std::tuple<::efl::eo::parent_type> > const& args)
{
   eo_do(eo, ::eo_parent_set(args.get<0>()._eo_raw));
}

inline Eo_Class const* get_eo_class(tag<::evas::rectangle>)
{
   return (EVAS_RECTANGLE_CLASS);
}

} } }
#endif // EFL_GENERATED_EVAS_RECTANGLE_HH

